找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 816|回复: 0

[分享] Getting the Midpoint of each Polyline Segment

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:13:43 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
      [CommandMethod("smp")]
        public void ShowMidPointOnEachSegment()
        {
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;

            Editor ed = doc.Editor;

            Database db = HostApplicationServices.WorkingDatabase;

            using (Transaction tr = db.TransactionManager.StartTransaction())
            {
                BlockTableRecord btr = tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite) as BlockTableRecord;

                Entity ename;

                PromptEntityOptions peo = new PromptEntityOptions("\nSelect Polyline: ");

                peo.SetRejectMessage("\nMust be a Polyline.");

                peo.AddAllowedClass(typeof(Polyline), false);
               
                PromptEntityResult retval = ed.GetEntity(peo);

                if (retval.Status != PromptStatus.OK)   return;

                Curve curv;

                ObjectId id;

                id = retval.ObjectId;

                ename = tr.GetObject(id, OpenMode.ForWrite) as Entity;

                curv = ename as Curve;
                if (curv == null)
                {
                    ed.WriteMessage("\nCould not cast object as Curve.");

                    return;
                }
                if (!curv.IsWriteEnabled)

                    curv.UpgradeOpen();

                double startParam, endParam;

                // get the start param, usually it starts at 0 or 1

                startParam = curv.StartParam;

                ed.WriteMessage("\nStartParam is: {0:f3}\n", startParam);

                // get the end param, for a polyline it's the total number of

                // vertex's -1

                endParam = curv.EndParam;

                ed.WriteMessage("\nEndParam is: {0:f3}\n", endParam);

                // now loop the parameters, adding 1.0 each iteration

               
                for (double i = startParam; i < endParam; ++i)
                {
                    Point3d pt;

                    pt = curv.GetPointAtParameter(i + 0.5);
                  //  DBPoint dp = new DBPoint(pt);
                    Circle cr = new Circle(pt, Vector3d.ZAxis, 2.5);
                    btr.AppendEntity(cr);
                    tr.AddNewlyCreatedDBObject(cr, true);

                    ed.WriteMessage("\nPoint: {0}, {1}, {2}\n", pt[0], pt[1], pt[2]);

                }
                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:47 , Processed in 0.296110 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表